#include "it9135.h"

bool  DevicePower;
static int it9135_pid_filter_ctrl(struct dvb_usb_adapter *adap, int onoff)
{
    int ret =0;
#if LINUX_VERSION_CODE >  KERNEL_VERSION(2,6,18)
    deb_data("%s: onoff:%d\n", __func__, onoff);

/*	if ( PDC->fc[adap->id].bEnPID !=  onoff )
		DL_ResetPID((BYTE)adap->id);
*/
	if (!onoff){
		deb_data("	Reset PID Table\n");
		DL_ResetPID((BYTE)adap->id);
		PDC->fc[adap->id].ulcPIDs = 0;
		memset(PDC->fc[adap->id].aulPIDs, 0, sizeof(FILTER_INFO));
	}
	PDC->fc[adap->id].bEnPID =  onoff;
	ret = DL_PIDOnOff((BYTE)adap->id, PDC->fc[adap->id].bEnPID);
#endif

	deb_data("	set pid onoff ok\n");
    return ret;
}

static int it9135_pid_filter(struct dvb_usb_adapter *adap, int index, u16 pidnum,
    int onoff)
{
	if (down_interruptible (&my_sem))
			return -ERESTARTSYS;
	
    int ret = 0;
 #if LINUX_VERSION_CODE >  KERNEL_VERSION(2,6,18)
    Pid pid;
    deb_data("- %s: set pid filter, feedcount %d, index %d, pid %x, onoff %d.\n",
	__func__, adap->feedcount, index, pidnum, onoff);

	
	if (onoff) { //add filter to table
		PDC->fc[adap->id].aulPIDs[index].filternum = pidnum;
		if (!PDC->fc[adap->id].aulPIDs[index].onoff ){
			PDC->fc[adap->id].aulPIDs[index].onoff = true;
			PDC->fc[adap->id].ulcPIDs ++;
		}
	}
	else{	//del filter from table
		PDC->fc[adap->id].aulPIDs[index].filternum = 0;
		if (PDC->fc[adap->id].aulPIDs[index].onoff ){
			PDC->fc[adap->id].aulPIDs[index].onoff = false;
			PDC->fc[adap->id].ulcPIDs --;
		}
	}


	if (onoff) {
		/* cannot use it as pid_filter_ctrl since it has to be done
		   before setting the first pid */
		if (adap->feedcount == 1) {
			deb_data("	first pid set, enable pid table\n");

			pid.sectionType = SectionType_TABLE;
	  		pid.table = 0x00;
	  		pid.duration = 0xFF;
	  
			ret = it9135_pid_filter_ctrl(adap, onoff);
			if (ret)
				return ret;
		}
		pid.value = (Word)pidnum;
		ret = DL_AddPID((BYTE)adap->id, index, pid);
		if (ret)
			return ret;
		 
	}
	else{
		
		pid.value = (Word)pidnum;
		ret = DL_RemovePID((BYTE)adap->id, index, pid);
		if (ret)
			return ret;
		
		if (adap->feedcount == 0) {
			deb_data("	last pid unset, disable pid table\n");
			ret = it9135_pid_filter_ctrl(adap, onoff);
			if (ret)
				return ret;
		}
		
	}
	
	deb_data("	set pid ok, total pid num :%d\n", PDC->fc[adap->id].ulcPIDs);
#endif

	up(&my_sem);
    return 0;
}

static int it9135_download_firmware(struct usb_device *udev, const struct firmware *fw)
{
	int ret=0;
	deb_data("- Enter %s Function -\n",__FUNCTION__);
	
	return ret;
}

static int it9135_powerctrl(struct dvb_usb_device *d, int onoff)
{
	if (down_interruptible (&my_sem))
			return -ERESTARTSYS;
	
	int ret;
	DevicePower = onoff;

#if LINUX_VERSION_CODE >  KERNEL_VERSION(2,6,18)
	deb_data("- Enter %s Function - chip=%d:%s\n",__FUNCTION__, d->adapter->id, onoff?"ON":"OFF");
	ret = DL_ApCtrl(d->adapter->id, onoff);
#else
	deb_data("- Enter %s Function - %s\n",__FUNCTION__, onoff?"ON":"OFF");
	ret = DL_ApCtrl(0, onoff);
#endif
	if(ret) deb_data("	it9135_powerctrl Fail: 0x%04X\n", ret);
	
	up(&my_sem);
	return ret;
}

static int it9135_identify_state(struct usb_device *udev, struct dvb_usb_device_properties *props,
			struct dvb_usb_device_description **desc, int *cold)
{
	deb_data("- Enter %s Function -\n",__FUNCTION__);
	*cold = 0;

	return 0;
}

static int it9135_frontend_attach(struct dvb_usb_adapter *adap)
{
#if LINUX_VERSION_CODE >  KERNEL_VERSION(2,6,18)
	deb_data("- Enter %s Function - chip=%d\n", __FUNCTION__, adap->id);
#else
	 deb_data("- Enter %s Function - \n", __FUNCTION__);
#endif
	adap->fe = it9135_attach(1);	

	return adap->fe == NULL ? -ENODEV : 0;
}

static int it9135_tuner_attach(struct dvb_usb_adapter *adap)
{
#if LINUX_VERSION_CODE >  KERNEL_VERSION(2,6,18)
	deb_data("- Enter %s Function - chip=%d\n",__FUNCTION__, adap->id);
#else
         deb_data("- Enter %s Function - \n", __FUNCTION__);
#endif
	tuner_attach(adap->fe);
	return  0;
}

static int it9135_streaming_ctrl(struct dvb_usb_adapter *adap, int onoff)
{
#if LINUX_VERSION_CODE >  KERNEL_VERSION(2,6,18)	    
	deb_data("- Enter %s Function - (%s) streaming state for chip=%d\n",__FUNCTION__, onoff?"ON":"OFF", adap->id);
	/*//PID off
	DL_ResetPID((BYTE)adap->id);
	PDC->fc[adap->id].bEnPID =  0;
	DL_PIDOnOff((BYTE)adap->id,0);
	*/
#else
	deb_data("- Enter %s Function - (%s) streaming state \n",__FUNCTION__, onoff?"ON":"OFF");
#endif
	
	return 0;
}

struct usb_device_id it9135_usb_id_table[] = {
		{ USB_DEVICE(0x048D,0x9005) },
		{ USB_DEVICE(0x048D,0x9006) },
		//{ USB_DEVICE(0x15A4,0x1002) },
		//{ USB_DEVICE(0x15A4,0x1003) },
		{ USB_DEVICE(0x048D,0x9135) },
		{ 0},		/* Terminating entry */
};
MODULE_DEVICE_TABLE(usb, it9135_usb_id_table);

struct dvb_usb_device_properties it9135_properties[] = {
	{
		.usb_ctrl          = DEVICE_SPECIFIC,
		.download_firmware = it9135_download_firmware,
		.no_reconnect      = 1,
		.power_ctrl		   = it9135_powerctrl,
		.identify_state    = it9135_identify_state,
		.num_adapters = 1,
		.adapter = {
			{
#ifdef DVB_USB_ADAP_NEED_PID_FILTER 
				.caps = DVB_USB_ADAP_HAS_PID_FILTER | DVB_USB_ADAP_PID_FILTER_CAN_BE_TURNED_OFF | DVB_USB_ADAP_NEED_PID_FILTERING,
#else
				.caps = DVB_USB_ADAP_HAS_PID_FILTER | DVB_USB_ADAP_PID_FILTER_CAN_BE_TURNED_OFF ,
#endif
				.pid_filter_count = 32,
				.pid_filter       = it9135_pid_filter,
				.pid_filter_ctrl  = it9135_pid_filter_ctrl,
				.frontend_attach  = it9135_frontend_attach,
				.tuner_attach     = it9135_tuner_attach,
				.streaming_ctrl   = it9135_streaming_ctrl,
				.stream = { 
					.type = USB_BULK,
					.count = 4,
					.endpoint = 0x84,
					.u = {
						.bulk = {
#ifdef DVB_USB_ADAP_NEED_PID_FILTER 
						.buffersize = (188*21),
#else
						.buffersize = (188*348),
#endif			
						}
					}
				}
			},
			{
#ifdef DVB_USB_ADAP_NEED_PID_FILTER 
				.caps = DVB_USB_ADAP_HAS_PID_FILTER | DVB_USB_ADAP_PID_FILTER_CAN_BE_TURNED_OFF | DVB_USB_ADAP_NEED_PID_FILTERING,
#else
				.caps = DVB_USB_ADAP_HAS_PID_FILTER | DVB_USB_ADAP_PID_FILTER_CAN_BE_TURNED_OFF ,
#endif
                           .pid_filter_count = 32,
                           .pid_filter       = it9135_pid_filter,
                           .pid_filter_ctrl  = it9135_pid_filter_ctrl,
				.frontend_attach  = it9135_frontend_attach,
				.tuner_attach     = it9135_tuner_attach,
				.streaming_ctrl   = it9135_streaming_ctrl,
				.stream = {
					.type = USB_BULK,
					.count = 4,
					.endpoint = 0x85,
					.u = {
					    .bulk = {
#ifdef DVB_USB_ADAP_NEED_PID_FILTER 
						.buffersize = (188*21),
#else
						.buffersize = (188*348),
#endif
					    }
					}
				}
			},
		},
		.num_device_descs =1,
		.devices =  {
                        {   	"ITEtech USB2.0 DVB-T Recevier",
                        	{ &it9135_usb_id_table[0], &it9135_usb_id_table[1],&it9135_usb_id_table[2], 
				&it9135_usb_id_table[3], &it9135_usb_id_table[4], NULL},
                            	{ NULL },
                        },
			{NULL},

		}
	}
};

int it9135_device_count = ARRAY_SIZE(it9135_properties);
